=begin
#MINDBODY Public API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v6

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.6

=end

require 'date'

module SwaggerClient
  class PurchaseGiftCardResponse
    # The barcode ID assigned to the purchased gift card.
    attr_accessor :barcode_id

    # The monetary value of the gift card.
    attr_accessor :value

    # The amount paid for the gift card by the purchaser.
    attr_accessor :amount_paid

    # The name of the purchaser.
    attr_accessor :from_name

    # The ID of the layout used for this gift card.
    attr_accessor :layout_id

    # Whether or not an email receipt was sent to the purchaser. If true, a receipt was sent.
    attr_accessor :email_receipt

    # The client ID of the purchaser.
    attr_accessor :purchaser_client_id

    # The purchaser’s email address.
    attr_accessor :purchaser_email

    # The recipient’s email address.
    attr_accessor :recipient_email

    # The sale ID of the gift card.
    attr_accessor :sale_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'barcode_id' => :'BarcodeId',
        :'value' => :'Value',
        :'amount_paid' => :'AmountPaid',
        :'from_name' => :'FromName',
        :'layout_id' => :'LayoutId',
        :'email_receipt' => :'EmailReceipt',
        :'purchaser_client_id' => :'PurchaserClientId',
        :'purchaser_email' => :'PurchaserEmail',
        :'recipient_email' => :'RecipientEmail',
        :'sale_id' => :'SaleId'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'barcode_id' => :'String',
        :'value' => :'Float',
        :'amount_paid' => :'Float',
        :'from_name' => :'String',
        :'layout_id' => :'Integer',
        :'email_receipt' => :'BOOLEAN',
        :'purchaser_client_id' => :'String',
        :'purchaser_email' => :'String',
        :'recipient_email' => :'String',
        :'sale_id' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'BarcodeId')
        self.barcode_id = attributes[:'BarcodeId']
      end

      if attributes.has_key?(:'Value')
        self.value = attributes[:'Value']
      end

      if attributes.has_key?(:'AmountPaid')
        self.amount_paid = attributes[:'AmountPaid']
      end

      if attributes.has_key?(:'FromName')
        self.from_name = attributes[:'FromName']
      end

      if attributes.has_key?(:'LayoutId')
        self.layout_id = attributes[:'LayoutId']
      end

      if attributes.has_key?(:'EmailReceipt')
        self.email_receipt = attributes[:'EmailReceipt']
      end

      if attributes.has_key?(:'PurchaserClientId')
        self.purchaser_client_id = attributes[:'PurchaserClientId']
      end

      if attributes.has_key?(:'PurchaserEmail')
        self.purchaser_email = attributes[:'PurchaserEmail']
      end

      if attributes.has_key?(:'RecipientEmail')
        self.recipient_email = attributes[:'RecipientEmail']
      end

      if attributes.has_key?(:'SaleId')
        self.sale_id = attributes[:'SaleId']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          barcode_id == o.barcode_id &&
          value == o.value &&
          amount_paid == o.amount_paid &&
          from_name == o.from_name &&
          layout_id == o.layout_id &&
          email_receipt == o.email_receipt &&
          purchaser_client_id == o.purchaser_client_id &&
          purchaser_email == o.purchaser_email &&
          recipient_email == o.recipient_email &&
          sale_id == o.sale_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [barcode_id, value, amount_paid, from_name, layout_id, email_receipt, purchaser_client_id, purchaser_email, recipient_email, sale_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
