=begin
#MINDBODY Public API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: v6

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.6

=end

require 'date'

module SwaggerClient
  class Service
    # The cost of the pricing option when sold at a physical location.
    attr_accessor :price

    # The cost of the pricing option when sold online.
    attr_accessor :online_price

    # The amount of tax included in the price, if inclusive pricing is enabled.
    attr_accessor :tax_included

    # The ID of the program that this pricing option applies to.
    attr_accessor :program_id

    # The tax rate applied to the pricing option. This field is populated only when you include a `LocationID` in the request.
    attr_accessor :tax_rate

    # The unique ID of the pricing option.
    attr_accessor :product_id

    # The barcode ID of the pricing option.
    attr_accessor :id

    # The name of the pricing option.
    attr_accessor :name

    # The initial count of usages available for the pricing option.
    attr_accessor :count

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'price' => :'Price',
        :'online_price' => :'OnlinePrice',
        :'tax_included' => :'TaxIncluded',
        :'program_id' => :'ProgramId',
        :'tax_rate' => :'TaxRate',
        :'product_id' => :'ProductId',
        :'id' => :'Id',
        :'name' => :'Name',
        :'count' => :'Count'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'price' => :'Float',
        :'online_price' => :'Float',
        :'tax_included' => :'Float',
        :'program_id' => :'Integer',
        :'tax_rate' => :'Float',
        :'product_id' => :'Float',
        :'id' => :'String',
        :'name' => :'String',
        :'count' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'Price')
        self.price = attributes[:'Price']
      end

      if attributes.has_key?(:'OnlinePrice')
        self.online_price = attributes[:'OnlinePrice']
      end

      if attributes.has_key?(:'TaxIncluded')
        self.tax_included = attributes[:'TaxIncluded']
      end

      if attributes.has_key?(:'ProgramId')
        self.program_id = attributes[:'ProgramId']
      end

      if attributes.has_key?(:'TaxRate')
        self.tax_rate = attributes[:'TaxRate']
      end

      if attributes.has_key?(:'ProductId')
        self.product_id = attributes[:'ProductId']
      end

      if attributes.has_key?(:'Id')
        self.id = attributes[:'Id']
      end

      if attributes.has_key?(:'Name')
        self.name = attributes[:'Name']
      end

      if attributes.has_key?(:'Count')
        self.count = attributes[:'Count']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          price == o.price &&
          online_price == o.online_price &&
          tax_included == o.tax_included &&
          program_id == o.program_id &&
          tax_rate == o.tax_rate &&
          product_id == o.product_id &&
          id == o.id &&
          name == o.name &&
          count == o.count
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [price, online_price, tax_included, program_id, tax_rate, product_id, id, name, count].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
